;;  Connected components in the grid -- for hardware   File:  grcchw.lisp

(in-package '*lisp)

(*PROCLAIM '(type (FIELD-PVAR 21) CC CW X Y))

(*DEFVAR CC (!! 0))    ; Component number
(*DEFVAR CW (!! 0))    ; Working component
(*DEFVAR X  (!! 0))    ; X address
(*DEFVAR Y  (!! 0))    ; Y address

(defvar xmx 3) (defvar ymx 3)   ; Maximum grid addresses

(*PROCLAIM '(type BOOLEAN-PVAR NB EB WB SB))

(*DEFVAR NB NIL!!)     ; Barrier on North, etc.
(*DEFVAR EB NIL!!)
(*DEFVAR WB NIL!!)
(*DEFVAR SB NIL!!)

(defun setup (p)
"Setup, 0 <= p <= 100 (integer) is probability of barrier"
 (*set CC (!! 0))
 (*set X (self-address-grid!! (!! 0)))  (*set Y (self-address-grid!! (!! 1)))
 (setq xmx (1- (dimension-size 0)))     (setq ymx (1- (dimension-size 1)))
 (*set NB (zerop!! X))  (*set SB (=!! X (!! xmx)))
 (*set WB (zerop!! Y))  (*set EB (=!! Y (!! ymx)))
 (*when (and!! (<!! X (!! xmx)) (<!! (random!! (!! 100)) (!! p)))
    (*set SB T!!)
    (*news T!! NB 1 0))
 (*when (and!! (<!! Y (!! ymx)) (<!! (random!! (!! 100)) (!! p)))
    (*set EB T!!)
    (*news T!! WB 0 1))
)

(defun gccs ()
"Calculate connected components, returns no. of cycles"
 (*set CC (self-address!!))
 (do ((n 0 (incf n)))
   ((not (gccx)) n))
)

(defun gccx ()
"Perform one cycle of sweeps, test for changes"
 (let (r)
  (*set CW CC)
  (*set CW
   (scan!! CW 'min!! :dimension 0 :direction :forward  :segment-pvar WB))
  (*set CW
   (scan!! CW 'min!! :dimension 0 :direction :backward :segment-pvar EB))
  (*set CW
   (scan!! CW 'min!! :dimension 1 :direction :forward  :segment-pvar NB))
  (*set CW
   (scan!! CW 'min!! :dimension 1 :direction :backward :segment-pvar SB))
  (setq r (*or (/=!! CC CW)))
  (*set CC CW)
  r)
)
